subroutine nfopen(format)
  use netcdf
  implicit none
  character dir*80
  character format*(*)
  character stat(10)*16
  character str(22)*8
  character units(4,10)*40
  character var(4)*8
  double precision actual_range(2,4,10)
  double precision ref_value
  integer i,j
  integer ncid(4,10)
  integer start(3)
  integer varid(4,10)
  real add_offset(4,10)
  real fmiss
  real ftrue(*)
  real ftrue2(4,10)
  real scale_factor(4,10)
  data stat(1)/'sextile1'/
  data stat(2)/'sextile3'/
  data stat(3)/'sextile5'/
  data stat(4)/'mean'/
  data stat(5)/'nobs'/
  data stat(6)/'stddev'/
  data stat(7)/'mean_day'/
  data stat(8)/'day_fraction'/
  data stat(9)/'mean_lon'/
  data stat(10)/'mean_lat'/
  data str(1)/'sst'/
  data str(2)/'air'/
  data str(3)/'wspd'/
  data str(4)/'uwnd'/
  data str(5)/'vwnd'/
  data str(6)/'slp'/
  data str(7)/'cldc'/
  data str(8)/'shum'/
  data str(9)/'rhum'/
  data str(10)/'smina'/
  data str(11)/'sflx'/
  data str(12)/'qsminq'/
  data str(13)/'lflx'/
  data str(14)/'upstr'/
  data str(15)/'vpstr'/
  data str(16)/'uairt'/
  data str(17)/'vairt'/
  data str(18)/'uspeh'/
  data str(19)/'vspeh'/
  data str(20)/'ulflx'/
  data str(21)/'vlflx'/
  data str(22)/'wspd3'/
  save

  read(*,'(a)')dir
  var(1) = str(index('SAWUVPCQRDEFGXYIJKLMNB',format(265:265)))
  var(2) = str(index('SAWUVPCQRDEFGXYIJKLMNB',format(331:331)))
  var(3) = str(index('SAWUVPCQRDEFGXYIJKLMNB',format(397:397)))
  var(4) = str(index('SAWUVPCQRDEFGXYIJKLMNB',format(463:463)))
  do j = 1,10
    do i = 4,1,-1
      call handle_err(nf90_open(trim(dir)//'/'//trim(var(i))//'.'//trim(stat(j))//'.nc', nf90_write, ncid(i,j)))
      call handle_err(nf90_inq_varid(ncid(i,j), var(i), varid(i,j)))
      call handle_err(nf90_get_att(ncid(i,j), varid(i,j), 'actual_range', actual_range(:,i,j)))
      call handle_err(nf90_get_att(ncid(i,j), varid(i,j), 'add_offset', add_offset(i,j)))
      call handle_err(nf90_get_att(ncid(i,j), varid(i,j), 'scale_factor', scale_factor(i,j)))
    enddo
  enddo
return

entry nfput(ftrue,ftrue2,fmiss)
  start(1) = nint(ftrue(4)/ftrue(3) + 1.)
  start(2) = nint((21-(21-180/nint(ftrue(3)))*nint(1.-mod(abs(ftrue(5)),1.)/0.5))/2. - ftrue(5)/ftrue(3))
  start(3) = nint((ftrue(1) - (1960-(1960-1800)*(nint(ftrue(3))/2)))*12. + ftrue(2))
  do j = 1,10
    do i = 4,1,-1
      if (ftrue2(i,j).ne.fmiss) then
        if (add_offset(i,j).ne.0.) then
          call handle_err(nf90_put_var(ncid(i,j), varid(i,j), &
                                                        nint((ftrue2(i,j)-add_offset(i,j))/scale_factor(i,j)), &
                                                                           start))
        else
          call handle_err(nf90_put_var(ncid(i,j), varid(i,j), ftrue2(i,j), start))
        endif
             if (actual_range(1,i,j) > ftrue2(i,j)) then
                 actual_range(1,i,j) = ftrue2(i,j)
        else if (actual_range(2,i,j) < ftrue2(i,j)) then
                 actual_range(2,i,j) = ftrue2(i,j)
        endif
      endif
    enddo
  enddo
return

entry nfclose(ftrue)
  do j = 1,10
    do i = 4,1,-1
      call handle_err(nf90_put_att(ncid(i,j), varid(i,j), 'actual_range', real(actual_range(:,i,j))))
      call handle_err(nf90_inq_varid(ncid(i,j), 'time', varid(i,j)))
      call handle_err(nf90_get_att(ncid(i,j), varid(i,j), 'units', units(i,j)))
      call value_out(ref_value,nint(ftrue(1)),nint(ftrue(2)),units(i,j))
      call handle_err(nf90_put_var(ncid(i,j), varid(i,j), ref_value, start(3:3)))
      call handle_err(nf90_get_att(ncid(i,j), varid(i,j), 'actual_range', actual_range(:,i,j)))
           if (actual_range(1,i,j) > ref_value) then
               actual_range(1,i,j) = ref_value
      else if (actual_range(2,i,j) < ref_value) then
               actual_range(2,i,j) = ref_value
      endif
      call handle_err(nf90_put_att(ncid(i,j), varid(i,j), 'actual_range', actual_range(:,i,j)))
      call handle_err(nf90_put_att(ncid(i,j), nf90_global, 'history', 'Release 2.5.1'//char(0)))
      call handle_err(nf90_close(ncid(i,j)))
    enddo
  enddo
end

subroutine handle_err(status)
  use netcdf
  implicit none
  integer, intent (in) :: status

  if (status /= nf90_noerr) then
    print *, trim(nf90_strerror(status))
    stop 'handle_err'
  end if
end subroutine handle_err

