c-----------------------------------------------------------------------3456789
      subroutine value_out(REF_VALUE,REF_YEAR,REF_MONTH,spec)
C
C Compute the number of time intervals from a start time to a
C reference time.
C
      IMPLICIT          NONE
      include 'udunits.inc'
      INTEGER           STATUS
      INTEGER           REF_YEAR
      INTEGER           REF_MONTH
      INTEGER           REF_DAY         / 1 /
      INTEGER           REF_HOUR        / 0 /
      INTEGER           REF_MINUTE      / 0 /
      REAL              REF_SECOND      / 0 /
      INTEGER           TIMECENTERS_UNIT
      DOUBLEPRECISION   REF_VALUE
      character*(*) spec

      STATUS = UTOPEN('/usr/local/etc/udunits.dat')
      IF (STATUS .NE. 0) THEN
          PRINT *, 'UTOPEN() = ', STATUS
          stop 'utopen'
      ENDIF

      TIMECENTERS_UNIT = UTMAKE()

      STATUS = UTDEC(spec,
     *                TIMECENTERS_UNIT)
      IF (STATUS .NE. 0) THEN
          PRINT *, 'UTDEC() = ', STATUS
          stop 'utdec'
      ENDIF

      STATUS = UTICALTIME(REF_YEAR, REF_MONTH, REF_DAY, REF_HOUR,
     *                REF_MINUTE, REF_SECOND, TIMECENTERS_UNIT,
     *                REF_VALUE)
      IF (STATUS .NE. 0) THEN
          PRINT *, 'UTICALTIME() = ', STATUS
          stop 'uticaltime'
      ENDIF
      call utcls()
      END
c-----------------------------------------------------------------------3456789
      subroutine value_in(REF_VALUE,REF_YEAR,REF_MONTH,spec)
C
C Compute a reference time from a start time to the number of
C time intervals.
C
      IMPLICIT          NONE
      include 'udunits.inc'
      INTEGER           STATUS
      INTEGER           REF_YEAR
      INTEGER           REF_MONTH
      INTEGER           REF_DAY         / 1 /
      INTEGER           REF_HOUR        / 0 /
      INTEGER           REF_MINUTE      / 0 /
      REAL              REF_SECOND      / 0 /
      INTEGER           TIMECENTERS_UNIT
      DOUBLEPRECISION   REF_VALUE
      character*(*) spec

      STATUS = UTOPEN('/usr/local/etc/udunits.dat')
      IF (STATUS .NE. 0) THEN
          PRINT *, 'UTOPEN() = ', STATUS
          stop 'utopen'
      ENDIF

      TIMECENTERS_UNIT = UTMAKE()

      STATUS = UTDEC(spec,
     *                TIMECENTERS_UNIT)
      IF (STATUS .NE. 0) THEN
          PRINT *, 'UTDEC() = ', STATUS
          stop 'utdec'
      ENDIF

      STATUS = UTCALTIME(REF_VALUE, TIMECENTERS_UNIT,
     *                REF_YEAR, REF_MONTH, REF_DAY, REF_HOUR,
     *                REF_MINUTE, REF_SECOND)
      IF (STATUS .NE. 0) THEN
          PRINT *, 'UTCALTIME() = ', STATUS
          stop 'utcaltime'
      ENDIF
      call utcls()
      END
